xquery version "3.1";

(:~
 :  ____    _                 _   ___ ___    __                   _    _      _ _    
 : |_  /___| |_ ___ _ _ ___  /_\ | _ \_ _|  / _|___ _ _   _____ _(_)__| |_ __| | |__ 
 :  / // _ \  _/ -_) '_/ _ \/ _ \|  _/| |  |  _/ _ \ '_| / -_) \ / (_-<  _/ _` | '_ \
 : /___\___/\__\___|_| \___/_/ \_\_| |___| |_| \___/_|   \___/_\_\_/__/\__\__,_|_.__/
 :                                                                                  
 :  REST interface of this module
 :
 : @author Johannes Biermann
 : @version 1.0
 :)

module namespace zrest="http://sade.textgrid.de/ns/zoteroapi/zoterorest";
declare namespace rest="http://exquery.org/ns/restxq";
declare namespace output="http://www.w3.org/2010/xslt-xquery-serialization";
import module namespace console="http://exist-db.org/xquery/console";
import module namespace util="http://exist-db.org/xquery/util";
import module namespace http="http://expath.org/ns/http-client";

import module namespace zotero="http://sade.textgrid.de/ns/zoteroapi/zotero" at "zotero.xqm";
import module namespace config="http://sade.textgrid.de/ns/zoteroapi/config" at "config.xqm";

declare 
    %rest:path("/zotero/{$itemId}") 
    %rest:GET 
    %output:media-type ('application/json')
    %output:method("binary")
function zrest:zotero($itemId) {
    let $file := config:get("zotero.datadirRoot") || "/" || config:get("zotero.datacollection") || "/json/"||$itemId||".json"
    let $avail := util:binary-doc-available($file)

    (: check if zotero ID is in cache, else try to download it :)
    let $dl := if ($avail eq false()) then
        zotero:fetchAndSaveItem($itemId)
        else ()
    return 
    if (util:binary-doc-available($file)) then
        util:binary-doc($file)
    else
        <rest:response>
            <http:response status="404" reason="Zotero ID not found">
                <http:header name="Content-Language" value="en"/>
                <http:header name="Content-Type" value="text/plain; charset=utf-8"/>
            </http:response>
        </rest:response>
    
};
 
